﻿local agony, corruption, ua 		= 0, 0, 0;
local mastery, haste, crit, spd 	= 0, 0, 0, 0;
local agony_targets 				= {};
local corruption_targets 			= {};
local ua_targets 					= {};
local target_id 					= 0;
local timer 						= 0;
local me 							= 0;

local agony_name					= GetSpellInfo(980);
local corruption_name				= GetSpellInfo(172);
local ua_name						= GetSpellInfo(30108);
local haunt_name					= GetSpellInfo(48181);

local shards						= 0;
local agony_bonus					= 1;
local corruption_bonus				= 1;	--2T14
local ua_bonus						= 1;
local options_frame_loaded			= false;

local event_type,source_GUID,dest_GUID,spell;

local HauntCooldown = CreateFrame("Cooldown", "HauntCD", HauntFrame);
HauntCooldown:SetAllPoints(HauntIcon);
local AgonyCooldown = CreateFrame("Cooldown", "AgonyCD", AgonyFrame);
AgonyCooldown:SetAllPoints(AgonyIcon);
local CorruptionCooldown = CreateFrame("Cooldown", "CorruptionCD", CorruptionFrame);
CorruptionCooldown:SetAllPoints(CorruptionIcon);
local UACooldown = CreateFrame("Cooldown", "UACD", UAFrame);
UACooldown:SetAllPoints(UAIcon);

HauntFrame.texture = HauntFrame:CreateTexture();
HauntFrame.texture:SetAllPoints(HauntFrame);
AgonyFrame.texture = AgonyFrame:CreateTexture();
AgonyFrame.texture:SetAllPoints(AgonyFrame);
CorruptionFrame.texture = CorruptionFrame:CreateTexture();
CorruptionFrame.texture:SetAllPoints(CorruptionFrame);
UAFrame.texture = UAFrame:CreateTexture();
UAFrame.texture:SetAllPoints(UAFrame);
SoulShards:SetTextHeight(20);

local function Round(num)
	return math.floor(num+.5)
end

local function GetDotDmg()
	local damage_bonus = (1+crit/100)*(1+mastery/100);
	local haste_bonus = 2/(1+haste/100);
	local agony_ticks = Round(24/haste_bonus);
	local corruption_ticks = Round(18/haste_bonus);
	local ua_ticks = Round(14/haste_bonus);
	agony = Round((agony_ticks*(280+spd*0.26)*damage_bonus*agony_bonus)/1000);
	corruption = Round(((1926+corruption_ticks*spd*0.2)*damage_bonus*corruption_bonus)/1000);
	ua = Round(((1792+ua_ticks*spd*0.24)*damage_bonus*ua_bonus)/1000);
	
	AgonyPower:SetText(agony);
	CorruptionPower:SetText(corruption);
	UAPower:SetText(ua);
end

local function SetFrames()
	local time_now = GetTime();
	local duration_left;
	local _,_,_,_,_,agony_duration,agony_expires = UnitDebuff("target", agony_name,"","player");
	local _,_,_,_,_,corruption_duration,corruption_expires = UnitDebuff("target", corruption_name,"","player");
	local _,_,_,_,_,ua_duration,ua_expires = UnitDebuff("target", ua_name,"","player");
	
	if(agony_expires ~= nil and agony_targets[tostring(target_id)]~= nil) then
		duration_left = agony_expires - time_now;
		AgonyCooldown:SetCooldown(time_now-agony_duration+duration_left, agony_duration);
		
		if(agony_targets[tostring(target_id)]>=agony and duration_left>12) then
			AgonyFrame.texture:SetTexture(0.5,0,0,0.5);
		elseif(agony_targets[tostring(target_id)]>=agony) then
			AgonyFrame.texture:SetTexture(0.5,0.5,0,0.5);
		elseif(agony_targets[tostring(target_id)]<agony and duration_left>12) then
			AgonyFrame.texture:SetTexture(0,0,0.5,0.5);
		else
			AgonyFrame.texture:SetTexture(0,0.5,0,0.5);
		end
		AgonyCooldown:Show();
	else
		AgonyCooldown:Hide();
		AgonyFrame.texture:SetTexture(0,0,0,0.5);
	end
	
	if(corruption_expires ~= nil and corruption_targets[tostring(target_id)]~= nil) then
		duration_left = corruption_expires - time_now;
		CorruptionCooldown:SetCooldown(time_now-corruption_duration+duration_left, corruption_duration);			
		if(corruption_targets[tostring(target_id)]>=corruption and duration_left>9) then
			CorruptionFrame.texture:SetTexture(0.5,0,0,0.5);
		elseif(corruption_targets[tostring(target_id)]>=corruption) then
			CorruptionFrame.texture:SetTexture(0.5,0.5,0,0.5);
		elseif(corruption_targets[tostring(target_id)]<corruption and duration_left>9) then
			CorruptionFrame.texture:SetTexture(0,0,0.5,0.5);
		else
			CorruptionFrame.texture:SetTexture(0,0.5,0,0.5);
		end
		CorruptionCooldown:Show();
	else
		CorruptionCooldown:Hide();
		CorruptionFrame.texture:SetTexture(0,0,0,0.5);
	end
	
	if(ua_expires ~= nil and ua_targets[tostring(target_id)]~= nil) then
		duration_left = ua_expires - time_now;
		UACooldown:SetCooldown(time_now-ua_duration+duration_left, ua_duration);
		if(ua_targets[tostring(target_id)]>=ua and duration_left>7) then
			UAFrame.texture:SetTexture(0.5,0,0,0.5);
		elseif(ua_targets[tostring(target_id)]>=ua) then
			UAFrame.texture:SetTexture(0.5,0.5,0,0.5);
		elseif(ua_targets[tostring(target_id)]<ua and duration_left>7) then
			UAFrame.texture:SetTexture(0,0,0.5,0.5);
		else
			UAFrame.texture:SetTexture(0,0.5,0,0.5);
		end
		UACooldown:Show();
	else
		UACooldown:Hide();
		UAFrame.texture:SetTexture(0,0,0,0.5);
	end
	
	if(AffDotsOptions.haunt) then
		local _,_,_,_,_,haunt_duration,haunt_expires = UnitDebuff("target", haunt_name,"","player");
		if(haunt_expires ~= nil) then
			duration_left = haunt_expires - time_now;
			HauntCooldown:SetCooldown(time_now-haunt_duration+duration_left, haunt_duration);
			HauntCooldown:Show();
			HauntFrame.texture:SetTexture(0,0,0,0.5);
		else
			HauntCooldown:Hide();
			HauntFrame.texture:SetTexture(0,0,0,0.5);
		end
		shards = UnitPower("player", 7)
		SoulShards:SetText(shards)
		if(shards == 4) then HauntFrame.texture:SetTexture(0,0.5,0,0.5) end
	end
end

local function GetRatings()
	local mas = GetMastery()*3.1;
	local has = GetRangedHaste();
	local cri = GetSpellCritChance(6);
	local dmg = GetSpellBonusDamage(6);
	if( mas ~= mastery or has ~= haste or cri ~= crit or dmg ~= spd) then
		mastery = mas;
		haste 	= has;
		crit 	= cri;
		spd 	= dmg;
		GetDotDmg();
	end
end

local function TargetDots()
	AgonyOnTarget:SetText(agony_targets[tostring(target_id)] or 0);
	CorruptionOnTarget:SetText(corruption_targets[tostring(target_id)] or 0);
	UAOnTarget:SetText(ua_targets[tostring(target_id)] or 0);
end

local function CleanTargets()
	for k,v in pairs(agony_targets) do agony_targets[k]=nil end
	for k,v in pairs(corruption_targets) do corruption_targets[k]=nil end
	for k,v in pairs(ua_targets) do ua_targets[k]=nil end
	AgonyOnTarget:SetText(0);
	CorruptionOnTarget:SetText(0);
	UAOnTarget:SetText(0);
end

local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= 0.2 then
		SetFrames();
		TargetDots();
        timer = 0;
    end
end

local function Events()
	if(GetSpecialization()==1 and select(2, UnitClass("player")) == "WARLOCK") then
		AffDotsFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		AffDotsFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
		AffDotsFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
		AffDotsFrame:RegisterEvent("COMBAT_RATING_UPDATE");
		AffDotsFrame:RegisterEvent("SPELL_POWER_CHANGED");
		AffDotsFrame:RegisterEvent("PLAYER_DAMAGE_DONE_MODS");
		AffDotsFrame:RegisterEvent("UNIT_INVENTORY_CHANGED");
		AffDotsFrame:RegisterEvent("UNIT_TARGET");
		AffDotsFrame:SetScript("OnUpdate", onUpdate);
		AffDotsFrame:Show();
		if(AffDotsOptions.hide == true) then AffDotsFrame:Hide() end
	else
		AffDotsFrame:SetScript("OnUpdate", nil);
		AffDotsFrame:UnregisterEvent("UNIT_INVENTORY_CHANGED");
		AffDotsFrame:UnregisterEvent("SPELL_POWER_CHANGED");
		AffDotsFrame:UnregisterEvent("COMBAT_RATING_UPDATE");
		AffDotsFrame:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS");
		AffDotsFrame:UnregisterEvent("PLAYER_REGEN_DISABLED");
		AffDotsFrame:UnregisterEvent("PLAYER_REGEN_ENABLED");
		AffDotsFrame:UnregisterEvent("UNIT_TARGET");
		AffDotsFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		AffDotsFrame:Hide();
	end
end

local function SetLocked()
	AffDotsFrame:SetMovable(not AffDotsOptions.locked);
	AffDotsFrame:EnableMouse(not AffDotsOptions.locked);
end

local function SetLayout()
	if(AffDotsOptions.layout == "vertical") then
		AffDotsFrame:SetSize(80*AffDotsOptions.scale, 160*AffDotsOptions.scale);
		AgonyFrame:SetSize(80, 40);
		CorruptionFrame:SetSize(80, 40);
		UAFrame:SetSize(80, 40);
		AgonyFrame:SetPoint("TOPLEFT", 0, AffDotsOptions.agony_order*-40);
		CorruptionFrame:SetPoint("TOPLEFT", 0, AffDotsOptions.corruption_order*-40);
		UAFrame:SetPoint("TOPLEFT", 0, AffDotsOptions.ua_order*-40);
		AgonyPower:SetPoint("TOPRIGHT", -7, -8);
		AgonyOnTarget:SetPoint("TOPRIGHT", -7, -23);
		CorruptionPower:SetPoint("TOPRIGHT", -7, -8);
		CorruptionOnTarget:SetPoint("TOPRIGHT", -7, -23);
		UAPower:SetPoint("TOPRIGHT", -7, -8);
		UAOnTarget:SetPoint("TOPRIGHT", -7, -23);
		AgonyIcon:SetPoint("TOPLEFT", 5, -5);
		CorruptionIcon:SetPoint("TOPLEFT", 5, -5);
		UAIcon:SetPoint("TOPLEFT", 5, -5);
		if(AffDotsOptions.haunt) then
			HauntFrame:SetSize(80, 40);
			HauntFrame:SetPoint("TOPLEFT", 0, AffDotsOptions.haunt_order*-40);
			HauntIcon:SetPoint("TOPLEFT", 5, -5);
			SoulShards:SetPoint("TOP", 17, -10);
		end
	else
		AffDotsFrame:SetSize(160*AffDotsOptions.scale, 70*AffDotsOptions.scale);
		AgonyFrame:SetSize(40, 70);
		CorruptionFrame:SetSize(40, 70);
		UAFrame:SetSize(40, 70);
		AgonyFrame:SetPoint("TOPLEFT", AffDotsOptions.agony_order*40, 0);
		CorruptionFrame:SetPoint("TOPLEFT", AffDotsOptions.corruption_order*40, 0);
		UAFrame:SetPoint("TOPLEFT", AffDotsOptions.ua_order*40, 0);
		AgonyPower:SetPoint("TOPRIGHT", -5, -5);
		AgonyOnTarget:SetPoint("TOPRIGHT", -5, -20);
		CorruptionPower:SetPoint("TOPRIGHT", -5, -5);
		CorruptionOnTarget:SetPoint("TOPRIGHT", -5, -20);
		UAPower:SetPoint("TOPRIGHT", -5, -5);
		UAOnTarget:SetPoint("TOPRIGHT", -5, -20);
		AgonyIcon:SetPoint("TOPLEFT", 5, -35);
		CorruptionIcon:SetPoint("TOPLEFT", 5, -35);
		UAIcon:SetPoint("TOPLEFT", 5, -35);
		if(AffDotsOptions.haunt) then
			HauntFrame:SetSize(40, 70);
			HauntFrame:SetPoint("TOPLEFT", AffDotsOptions.haunt_order*40, 0);
			HauntIcon:SetPoint("TOPLEFT", 5, -35);
			SoulShards:SetPoint("TOP", 0, -10);
		end
	end
	AgonyFrame:SetScale(AffDotsOptions.scale);
	CorruptionFrame:SetScale(AffDotsOptions.scale);
	UAFrame:SetScale(AffDotsOptions.scale);
	HauntFrame:SetScale(AffDotsOptions.scale);
	if(AffDotsOptions.x and AffDotsOptions.y) then
		AffDotsFrame:SetPoint("TOPLEFT", AffDotsOptions.x, AffDotsOptions.y);
	end
	if(not AffDotsOptions.haunt) then HauntFrame:Hide()
	else HauntFrame:Show()
	end
end

function OptionsFrame()
	AffDotsFrame.options = CreateFrame( "Frame", "AffDotsOptionsFrame", UIParent );
end

AffDotsFrame:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving();
		self.isMoving = true;
	end
end)
AffDotsFrame:SetScript("OnMouseUp", function(self, button)
	local _,_,_, x, y = self:GetPoint();
	AffDotsOptions.x = x;
	AffDotsOptions.y = y;
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)
AffDotsFrame:SetScript("OnHide", function(self)
	if ( self.isMoving ) then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)

local function ShowOptions()
	if(options_frame_loaded) then
		AffDotsOptionsFrame:Show();
		return
	else
		options_frame_loaded = true;
	end
	
	local OptionsFrame = CreateFrame('Frame', 'AffDotsOptionsFrame', UIParent)
	OptionsFrame:SetWidth(250)
	OptionsFrame:SetHeight(350)
	OptionsFrame:SetPoint("CENTER", UIParent, "CENTER")
	OptionsFrame:EnableMouse(true)
	OptionsFrame:SetMovable(true)
	OptionsFrame:RegisterForDrag("LeftButton")
	OptionsFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	OptionsFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	OptionsFrame.texture = OptionsFrame:CreateTexture()
	OptionsFrame.texture:SetAllPoints(OptionsFrame)
	OptionsFrame.texture:SetTexture(0,0,0,0.9)
	
	local locked = CreateFrame("CheckButton", "AffDotsLockCheckbox", OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	locked:ClearAllPoints()
	locked:SetPoint("TOPLEFT", 10, -10)
	if(AffDotsOptions.locked) then locked:SetChecked(1) end
	_G[locked:GetName() .. "Text"]:SetText("Locked")
	locked:SetScript("OnClick", function(self)
		AffDotsOptions.locked = not AffDotsOptions.locked;
		SetLocked();
	end)
	
	local hide = CreateFrame("CheckButton", "AffDotsHideCheckbox", OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	hide:ClearAllPoints()
	hide:SetPoint("TOPLEFT", 10, -30)
	if(AffDotsOptions.hide) then hide:SetChecked(1) end
	_G[hide:GetName() .. "Text"]:SetText("Hide when not in combat")
	hide:SetScript("OnClick", function(self)
		AffDotsOptions.hide = not AffDotsOptions.hide;
		if(AffDotsOptions.hide and not InCombatLockdown()) then 
			UIFrameFadeOut(AffDotsFrame, 1, 1, 0)
		else
			UIFrameFadeIn(AffDotsFrame, 1, 0, 1)
		end
	end)
	
	local layout = CreateFrame("CheckButton", "AffDotsLayout", OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	layout:ClearAllPoints()
	layout:SetPoint("TOPLEFT", 10, -70)
	if(AffDotsOptions.layout == "horizontal") then layout:SetChecked(1) end
	_G[layout:GetName() .. "Text"]:SetText("Horizontal layout")
	layout:SetScript("OnClick", function(self)
		if(AffDotsOptions.layout == "horizontal") then AffDotsOptions.layout = "vertical"
		else AffDotsOptions.layout = "horizontal"
		end
		SetLayout()
	end)
	
	local haunt = CreateFrame("CheckButton", "AffDotsHauntCheckbox", OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	haunt:ClearAllPoints()
	haunt:SetPoint("TOPLEFT", 10, -50)
	if(AffDotsOptions.haunt) then haunt:SetChecked(1) end
	_G[haunt:GetName() .. "Text"]:SetText("Enable Haunt")
	haunt:SetScript("OnClick", function(self)
		AffDotsOptions.haunt = not AffDotsOptions.haunt;
		SetLayout();
	end)

	scale_text = OptionsFrame:CreateFontString()
	scale_text:SetPoint("TOPLEFT", 10, -150)
	scale_text:SetFont("Fonts\\ARIALN.TTF", 14, THICKOUTLINE)
	scale_text:SetText("Frame size")

	CreateFrame('Slider', 'ScaleSlider', OptionsFrame, 'OptionsSliderTemplate')
	ScaleSlider:ClearAllPoints()
	ScaleSlider:SetPoint("TOP", OptionsFrame, "TOP", 35, -148)
	ScaleSlider:SetMinMaxValues(0.3, 3)
	ScaleSlider:SetValueStep(0.1)
	ScaleSlider:SetValue(AffDotsOptions.scale)
	getglobal(ScaleSlider:GetName() .. 'Low'):SetText('0.3')
	getglobal(ScaleSlider:GetName() .. 'High'):SetText('3')
	getglobal(ScaleSlider:GetName() .. 'Text'):SetText(AffDotsOptions.scale)
	ScaleSlider:Show()
	ScaleSlider:SetScript("OnValueChanged", function()
		AffDotsOptions.scale = Round(ScaleSlider:GetValue()*10)/10
		getglobal(ScaleSlider:GetName() .. 'Text'):SetText(AffDotsOptions.scale)
		SetLayout()
	end)
	
	order_text = OptionsFrame:CreateFontString()
	order_text:SetPoint("TOPLEFT", 10, -180)
	order_text:SetFont("Fonts\\ARIALN.TTF", 14, THICKOUTLINE)
	order_text:SetText("Position:")
	
	haunt_order_text = OptionsFrame:CreateFontString()
	haunt_order_text:SetPoint("TOPLEFT", 10, -205)
	haunt_order_text:SetFont("Fonts\\ARIALN.TTF", 14, THICKOUTLINE)
	haunt_order_text:SetText("Haunt")
	
	CreateFrame('Slider', 'HauntSlider', OptionsFrame, 'OptionsSliderTemplate')
	HauntSlider:ClearAllPoints()
	HauntSlider:SetPoint("TOP", OptionsFrame, "TOP", 35, -203)
	HauntSlider:SetMinMaxValues(1, 4)
	HauntSlider:SetValueStep(1);
	HauntSlider:SetValue(AffDotsOptions.haunt_order+1)
	getglobal(HauntSlider:GetName() .. 'Low'):SetText('');
	getglobal(HauntSlider:GetName() .. 'High'):SetText('');
	HauntSlider:Show()
	HauntSlider:SetScript("OnValueChanged", function()
		AffDotsOptions.haunt_order = Round(HauntSlider:GetValue())-1
		SetLayout();
	end)
	
	agony_order_text = OptionsFrame:CreateFontString()
	agony_order_text:SetPoint("TOPLEFT", 10, -230)
	agony_order_text:SetFont("Fonts\\ARIALN.TTF", 14, THICKOUTLINE)
	agony_order_text:SetText("Agony")
	
	CreateFrame('Slider', 'AgonySlider', OptionsFrame, 'OptionsSliderTemplate')
	AgonySlider:ClearAllPoints()
	AgonySlider:SetPoint("TOP", OptionsFrame, "TOP", 35, -228)
	AgonySlider:SetMinMaxValues(1, 4)
	AgonySlider:SetValueStep(1);
	AgonySlider:SetValue(AffDotsOptions.agony_order+1)
	getglobal(AgonySlider:GetName() .. 'Low'):SetText('');
	getglobal(AgonySlider:GetName() .. 'High'):SetText('');
	AgonySlider:Show()
	AgonySlider:SetScript("OnValueChanged", function()
		AffDotsOptions.agony_order = Round(AgonySlider:GetValue())-1
		SetLayout();
	end)
	
	corruption_order_text = OptionsFrame:CreateFontString()
	corruption_order_text:SetPoint("TOPLEFT", 10, -255)
	corruption_order_text:SetFont("Fonts\\ARIALN.TTF", 14, THICKOUTLINE)
	corruption_order_text:SetText("Corruption")
	
	CreateFrame('Slider', 'CorruptionSlider', OptionsFrame, 'OptionsSliderTemplate')
	CorruptionSlider:ClearAllPoints()
	CorruptionSlider:SetPoint("TOP", OptionsFrame, "TOP", 35, -253)
	CorruptionSlider:SetMinMaxValues(1, 4)
	CorruptionSlider:SetValueStep(1);
	CorruptionSlider:SetValue(AffDotsOptions.corruption_order+1)
	getglobal(CorruptionSlider:GetName() .. 'Low'):SetText('');
	getglobal(CorruptionSlider:GetName() .. 'High'):SetText('');
	CorruptionSlider:Show()
	CorruptionSlider:SetScript("OnValueChanged", function()
		AffDotsOptions.corruption_order = Round(CorruptionSlider:GetValue())-1
		SetLayout();
	end)
	
	ua_order_text = OptionsFrame:CreateFontString()
	ua_order_text:SetPoint("TOPLEFT", 10, -280)
	ua_order_text:SetFont("Fonts\\ARIALN.TTF", 14, THICKOUTLINE)
	ua_order_text:SetText("UA")
	
	CreateFrame('Slider', 'UASlider', OptionsFrame, 'OptionsSliderTemplate')
	UASlider:ClearAllPoints()
	UASlider:SetPoint("TOP", OptionsFrame, "TOP", 35, -278)
	UASlider:SetMinMaxValues(1, 4)
	UASlider:SetValueStep(1);
	UASlider:SetValue(AffDotsOptions.ua_order+1)
	getglobal(UASlider:GetName() .. 'Low'):SetText('');
	getglobal(UASlider:GetName() .. 'High'):SetText('');
	UASlider:Show()
	UASlider:SetScript("OnValueChanged", function()
		AffDotsOptions.ua_order = Round(UASlider:GetValue())-1
		SetLayout();
	end)
	
	local close_button = CreateFrame("BUTTON", nil, OptionsFrame, "UIPanelButtonTemplate")
	close_button:SetWidth(100)
	close_button:SetHeight(22)
	close_button:SetText("Close")
	close_button:SetPoint("BOTTOMRIGHT", OptionsFrame, "BOTTOMRIGHT", -20, 20)
	close_button:SetScript("OnClick", function() OptionsFrame:Hide() end)
end

SLASH_AFFDOTS1 = '/affdots';
local function handler(msg, editBox)
	ShowOptions();
end
SlashCmdList["AFFDOTS"] = handler;

local function GetBonus()
	local t14_equipped	= 0;
	local t14set_ids 	= { 86709, 86710, 86711, 86712, 86713,
							85369, 85370, 85371, 85372, 85373,
							87187, 87188, 87189, 87190, 87191}
	local slot_ids		= { 1, 3, 5, 6, 7, 8, 9 ,10}
	for i,v in ipairs(slot_ids) do
		local id = GetInventoryItemID("player", v)
		for j, k in ipairs(t14set_ids) do
			if k == id then
				t14_equipped = t14_equipped + 1
			end
		end
	end
	if t14_equipped >= 2 then corruption_bonus = 1.1 else corruption_bonus = 1 end
end

local function VariablesLoaded()
	if(not AffDotsOptions) then AffDotsOptions = {} end
	if(not AffDotsOptions.layout) then AffDotsOptions.layout = "vertical" end
	if(not AffDotsOptions.scale) then AffDotsOptions.scale = "1" end
	if(not AffDotsOptions.agony_order) then AffDotsOptions.agony_order = 0 end
	if(not AffDotsOptions.corruption_order) then AffDotsOptions.corruption_order = 1 end
	if(not AffDotsOptions.ua_order) then AffDotsOptions.ua_order = 2 end
	if(not AffDotsOptions.haunt_order) then AffDotsOptions.haunt_order = 3 end
	if(not AffDotsOptions.haunt) then AffDotsOptions.haunt = false end
	SetLayout();
	if(not AffDotsOptions.locked) then AffDotsOptions.locked = false end
	SetLocked();
	if(not AffDotsOptions.hide) then AffDotsOptions.hide = false end
end

function OnEvent(frame, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_,spell = select(1, ...)
		if(source_GUID == me and dest_GUID ~= me) then
			if(event_type == "SPELL_DAMAGE" and spell == 77799) then
				corruption_targets[tostring(dest_GUID)] = corruption;
				ua_targets[tostring(dest_GUID)] = ua
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172 or spell == 87389) then
					corruption_targets[tostring(dest_GUID)] = corruption
				elseif(spell == 980) then
					agony_targets[tostring(dest_GUID)] = agony
				elseif(spell == 30108) then
					ua_targets[tostring(dest_GUID)] = ua
				end
			elseif(event_type == "SPELL_AURA_REMOVED") then
				if(spell == 172 or spell == 87389) then
					corruption_targets[tostring(dest_GUID)]=nil
				elseif(spell == 980) then
					agony_targets[tostring(dest_GUID)]=nil
				elseif(spell == 30108) then
					ua_targets[tostring(dest_GUID)]=nil
				end
			end
		end
	elseif(event == "PLAYER_DAMAGE_DONE_MODS" or event == "COMBAT_RATING_UPDATE" or event == "SPELL_POWER_CHANGED") then
		GetRatings();
	elseif event == "PLAYER_REGEN_ENABLED" then
		if(AffDotsOptions.hide == true) then 
			UIFrameFadeOut(AffDotsFrame, 1, 1, 0)
		end
	elseif event == "PLAYER_REGEN_DISABLED" then
		if(AffDotsOptions.hide == true) then
			UIFrameFadeIn(AffDotsFrame, 1, 0, 1)
		end
		CleanTargets();
	elseif event == "UNIT_TARGET" then
		target_id = UnitGUID("target")
	elseif event == "UNIT_INVENTORY_CHANGED" then
		GetBonus()
		GetDotDmg()
	elseif event == "VARIABLES_LOADED" then
		VariablesLoaded()
	else
		me = UnitGUID("player")
		GetBonus()
		GetRatings()
		Events()
	end
end